#!/bin/bash

chemin="$(cd "$(dirname "$0")";pwd)"

# il faut se déplacer dans le dossier de l'interface ou indiquer le path entier du glade.
cd "${chemin}"


#######################
##### Preferences #####
#######################
fichier_pref="${HOME}/.config/screencastor/preferences"

if [[ ! -e "${fichier_pref}" ]]
then
	# Récupération de la resolution
	resolution=$(xwininfo -root) resolution=${resolution##*-geometry } resolution=${resolution%%+*}

	echo "langue=\"$(sed 's/_.*//' <<< ${LANG})\"
geo_fenetre=

### Preferences Video
video_no=\"False\"
video_codec=\"libx264\"

video_reso_l_out=\"${resolution%x*}\"
video_reso_h_out=\"${resolution#*x}\"
video_reso_l_in=\"${resolution%x*}\"
video_reso_h_in=\"${resolution#*x}\"
video_bitrate=\"700\"
video_tolerance=\"4000\"
video_qmin=\"10\"
video_qmax=\"50\"
video_desentralacement=\"False\"
video_multithreads=\"True\"
video_fps=\"30\"
video_framekey=\"250\"
video_framekey_min=\"25\"
video_treillis=\"1\"
video_deblockalpha=\"0\"
video_deblockbeta=\"0\"
video_bframe=\"16\"
video_references=\"0\"
video_lookahead=\"16\"
video_gris=\"False\"
video_debit=\"fixe\"
video_diasize=\"hex\"

x264_nocabac=\"False\"
x264_vpre=\"lossless_ultrafast\"
x264_crf=\"20\"
x264_algorithme=\"6\"

webm_level=\"116\"

### Preferences Audio
audio_no=\"False\"
audio_codec=\"libvorbis\"
audio_frequence=\"44100\"
audio_provenance=\"pulse\"
audio_bitrate=\"128\"
audio_serveur=\"alsa\"
audio_canal=\"2\"

### Preferences sortie
sortie_dossier=\"${HOME}\"
auto_suppr=\"False\"
sortie_fps=\"25\"
sortie_display=\":0.0\"
sortie_emplacement=\"0,0\"
sortie_extension_audio=\"ogg\"
sortie_extension_video=\"mkv\"
capture_heure=\"0\"
capture_minute=\"0\"
capture_seconde=\"0\"
delay_heure=\"0\"
delay_minute=\"0\"
delay_seconde=\"0\"

### Preferences grahiques
systray_icone=\"True\"
systray_auto=\"False\"
systray_blink=\"False\"
option_onglet=\"False\"
unity=" > "${fichier_pref}"
fi

###############################
##### Lancement graphique #####
###############################

while true
do
	#######################
	##### Traductions #####
	#######################
	# Chargement de variables depuis le fichier de config
	[[ -f "${fichier_pref}" ]] && source "${fichier_pref}"

	#Pour exporter la librairie de gettext
	set -a
	source gettext.sh
	set +a
	[[ ${langue} ]] && export LANGUAGE=${langue}
	export TEXTDOMAIN=screencastor
	export TEXTDOMAINDIR="${chemin}/locale"
	. gettext.sh

	#xgettext -o screencastor.pot screencastor.glade *.sh --from-code UTF-8
	#mise a jour : msgmerge -o new_screencastor.po screencastor.po screencastor.pot
	#msginit -i screencastor.pot -o screencastor.po
	#msgfmt screencastor.po -o screencastor.mo


	########################
	##### Glade2Script #####
	########################
	./screencastor.py -d --glade ./screencastor.glade \
--sourceview='_code_ffmpeg,_box_code_ffmpeg' \
--tree '@@audio_codec@@Nom du codec|Déscription du codec' \
--terminal='_terminal:590x150' \
--combobox='@@_audio_provenance@@col
pulse
/dev/dsp1
hw:0,0
hw:1,0' \
--combobox='@@_audio_serveur@@col
alsa
oss' \
--combobox='@@_x264_vpre@@col
lossless_ultrafast
ultrafast
superfast
veryfast
faster
fast
medium
slow
slower
veryslow
placebo' \
--combobox='@@_video_diasize@@col
epzs - diamand
hex - hexagonale
umh - multi-hexagonale
full - complete' \
--combobox='@@_sortie_extension_video@@col
avi
flv
mkv
mp4
nut
webm' \
--combobox='@@_sortie_extension_audio@@col
aac
ac3
flac
ogg
mka
mp3
wav
wma' \
--combobox='@@_webm_level@@col
116 - Lent/Qualité
216 - Moyen
214 - Rapide/Qualité médiocre' \
--combobox='@@_audio_frequence@@col
48000
44100
32000
22000
11000' \
--combobox='@@_audio_bitrate@@col
320
224
192
160
128
112
96
80
64' \
--combobox='@@_langue@@col|IMG%%22
English|/usr/share/locale/l10n/gb/flag.png
Français|/usr/share/locale/l10n/fr/flag.png'

	# En fonction de la sortie, quitte ou continue la boucle
	#EXIT@SAVE => EXIT="yes" => code retour=0
	#EXIT@ => EXIT="no" => code retour=1
	[[ ${?} == 1 ]] && break
done

PIDS=$(pstree -p $$) PIDS=${PIDS//[!0-9]/$'\n'} PIDS=$(sed '/^$/d' <<< "${PIDS}") PIDS=${PIDS#*$'\n'} PIDS=$(sort -nr <<< "${PIDS}") PIDS=${PIDS//$'\n'/ }

# Creation d'un fichier qui killera tous les processus
echo '#!/bin/bash
for pid in '${PIDS}'; do [[ $(ps h ${pid}) ]] && kill ${pid}; done
sleep 0.5
while [[ $(pstree | grep "screencastor.sh") && -z $(pstree | grep "go_screencastor") ]]
do
	killall -9 screencastor.sh
	sleep 0.2
done

rm /tmp/kill_screencastor' > /tmp/kill_screencastor

# lancement du script killer
bash /tmp/kill_screencastor &

exit
